const { exec } = require("child_process");
const fs = require("fs");

function logic({ name, location }) {
  console.log(`The name of your component is ${name} and it will be installed in
    components/${location}`);
}

function installComponent({ name, location }) {
  location = location === "UI" ? "runtime/ui" : location;
  const path = `./components/${location}`;
  exec(`cd ${path} && npm init stencil component ${name}`, (err, stdout) => {
    changeNames(path, name);
  });
}

function changeNames(path, name) {
  const files = [
    "package.json",
    "stencil.config.ts",
    "tsconfig.json",
    "src/components/my-component/my-component.tsx"
  ];
  files.forEach(file => {
    const fullpath = `${path}/${name}/${file}`;
    fs.readFile(fullpath, "utf8", (err, data) => {
      if (err) {
        console.log(err);
      } else {
        fs.writeFile(fullpath, data.replace(/my-component/g, name), err => {
          if (err) console.log("fodeu");
        });
      }
    });
  });
  fs.rename(
    `${path}/${name}/src/components/my-component`,
    `${path}/${name}/src/components/${name}`
  );
}

module.exports.log = logic;
module.exports.installComponent = installComponent;
